#include <pic12f675.h>

#pragma config "BOREN = ON", "FOSC = INTRCIO", "MCLRE = OFF", "WDTE = OFF", /*"IOSCFS = 8MHZ",*/ "CP = OFF", "PWRTE = OFF"

#define bait unsigned char
#define slovo unsigned int

const slovo znaki [16] = { 0xff88, 0x6f00, 0xbf84, 0xff04, 0x6f0c, 0xdf0c, 0xdf8c, 0x7f00,
                           0xff8c, 0xff0c/*, 0x7f8c, 0xcf8c, 0x9f88, 0xef84, 0x9f8c, 0x1f8c*/ };

const bait porjadok [4] = { 0xb, 0xd, 0x7, 0xe };

union typ_flagi {
  struct {
//    unsigned vyb_seg    :2;
    unsigned vkl_zvuk   :1;
    unsigned vkl_otschet:1;
    unsigned nastr      :1;
    unsigned vyb_ch_m   :1;
    unsigned strob_plmn :1;
    unsigned vr_rele    :1;
    unsigned strob_vyb  :1;
    unsigned gotovo     :1;
  };
} flagi;

/*union typ_flagi2 {
  struct {
//    unsigned vyb_seg    :2;
    unsigned         : 7;
    unsigned mod_zvuk: 1;
  };
} flagi2;*/

union vr_struc {
  unsigned int znach;
  struct { unsigned char minuty, chas; } baity;
} /*prob,*/ vremja, rele, ind_knop, * tek_ind;

#define vr_m vremja.baity.minuty
#define vr_ch vremja.baity.chas

#define rel_m rele.baity.minuty
#define rel_ch rele.baity.chas

//bait * vr_m;
//bait * vr_ch;
bait * ust_m;
bait * ust_ch;

bait sch_ust = 0;

bait sch_gotovo;

//bait minuty = 0;
//bait chas = 0;

/*union slovo {
  unsigned int znach;
  struct { unsigned char mladsh, starsh; } baity;
} impuls, promez;*/

//#include <stdio.h>
//#include <stdlib.h>

//#define v_takt GP1
//#define v_dann GP2
//#define v_zvuka GP5
#define v_takt GPIO1
#define v_dann GPIO2
#define v_zvuka GPIO5

/*
 *
 */
//slovo impuls;// = 0;
//slovo promez;// = 0x3ff;
//unsigned char impuls = 0;
//unsigned char promez = 0xff;
//unsigned int vrem;
//unsigned char vrem;

bait zaderzh;

void otp_bait (bait dann, bait strob) {
  bait schet;
  schet = 8;
  while (schet) {
    v_dann = dann & 1;
    v_takt = 0;
    //zaderzh = 1;
    //while (zaderzh) zaderzh--;
    dann >>= 1;

    if ((schet==1) && strob) {
      zaderzh = 3;
      while (zaderzh) zaderzh--;
    }

    v_takt = 1;
    schet--;
  }
}

//bait vremsch;
bait sch_seg = 1;
//slovo sch_sec = 0;

//bait del_sec;

bait del_vrem;
bait del_vrem1 = 0;
bait del_vrem2 = 0;
slovo vyv_bukva;

bait knopki;

bait sch_vozv; // schet vozvrata k chasam iz rele

void schet_chisla (bait * chis) {
  (*chis) ++;
  if (((*chis) & 0xf)==10) {
    *chis &= 0xf0; *chis += 0x10;
  }
}

void obr_schet_chisla (bait * chis) {
  if ((*chis) & 0xf) (*chis)--; else { *chis |= 9;
    if ((*chis) >> 4) *chis -= 0x10;
  }
}

void schet_vrem () {
  schet_chisla(&vr_m);
  if (vr_m==0x60) { schet_chisla(&vr_ch); vr_m = 0; }
  if (vr_ch==0x24) vr_ch = 0;
}

void schet_rele () {
  if ((rel_m) || (rel_ch)) {
    if (rel_m) obr_schet_chisla (&rel_m); else { rel_m = 0x59;
      if (rel_ch) obr_schet_chisla (&rel_ch); else rel_ch = 0x23;
    }
  }
}

void interrupt Takty (void) {
  //if (PIR1bits.T1IF) {
    TMR1H = 0xf8;//0xfd;
    TMR1L = 0x61;

    PIR1bits.T1IF = 0;

    if ((del_vrem & 0x1)/* == 3*/) GP0 = 1; else GP0 = 0;

    vyv_bukva = znaki[(/*vremja.znach*/(*tek_ind).znach >> ((3-sch_seg) << 2)) & 0xf];

    if ((del_vrem1==2) && !flagi.nastr) vyv_bukva |= 2;

    if (flagi.vr_rele) vyv_bukva |= 1;
    if (flagi.vkl_zvuk) vyv_bukva |= 0x40;
    if (flagi.vkl_otschet) vyv_bukva |= 0x20; // rele

    vyv_bukva = ~vyv_bukva;

    if (!((((sch_seg >> 1)==/*flagi.vyb_seg*/flagi.vyb_ch_m) && (del_vrem1 & 0x01)) ||
           ((sch_seg >> 1)!=/*flagi.vyb_seg*/flagi.vyb_ch_m) || !flagi.nastr) ||
            (flagi.gotovo && (del_vrem1 & 0x01))) vyv_bukva |= 0xf08c;

    otp_bait(vyv_bukva, 0);
    otp_bait((vyv_bukva >> 8) | porjadok[sch_seg], 1);
    
    
    /*if (sch_seg==3) sch_seg = 0; else*/ sch_seg++;
    sch_seg &= 3;
    
    //if ((del_vrem & 0x1)/* == 3*/) GP0 = 1; else GP0 = 0;
    
    /*if (del_vrem==250) {
      del_vrem = 0;
      schet_vrem ();
    } else*/ del_vrem++;

               //if (!del_vrem) del_vrem1 ++;
 // }
  //PIR1bits.ADIF = 0;
}

void perekl_v_chasy () {
  flagi.vr_rele = 0;
  tek_ind = &vremja;
  ust_m = &vremja.baity.minuty;
  ust_ch = &vremja.baity.chas;

  flagi.vkl_otschet = 0;
  flagi.gotovo = 0;
  flagi.nastr = 0;
  flagi.vyb_ch_m = 1;
}

//bait schzvk;
bait usk_schet;
bait sch_pov;

#define knop_vyb 26
#define knop_pls 16//25
#define knop_min 21//23
#define knop_vkl 25//21
#define knop_vyk 23//16

int main() {//(int argc, char** argv) {
  TRISIO = 0x18; // 4 <- , 3 <- , 2 ->, 1 ->, 0 ->

  GP0 = 0;

  T1CONbits.TMR1ON = 1;
  T1CONbits.T1CKPS = 1;
  //T1CONbits.TMR1GE = 0;

  CMCON = 7;
  ANSEL = 0x38; // Fvnut, 3 - analog vhod
//  ADCON0 = 0x89; // pravoe vyravn, 2 kanal, vkl
  ADCON0 = 0x0d; // levoe vyravn, 3 kanal, vkl
  VRCON = 0;

//  impuls.znach = 0;
//  promez.znach = 0x3ff;

  ADCON0bits.GO_DONE = 1;

  tek_ind = /*&ind_knop;*/&vremja;
  vr_m = 0;//&vremja.baity.minuty;//  0;
  vr_ch = 0;//&vremja.baity.chas;// 0;
  ust_m = &vremja.baity.minuty;
  ust_ch = &vremja.baity.chas;
  flagi.vyb_ch_m = 1;
  flagi.vkl_zvuk = 1;
  flagi.vkl_otschet = 0;
  flagi.gotovo = 0;

  v_zvuka = 0;

  sch_vozv = 0;

  //T1CONbits.TMR1ON = 1;
 // T1CONbits.T1CKPS = 1;
  //PIE1bits.ADIE = 0;
  PIE1bits.TMR1IE = 1;
  INTCONbits.PEIE = 1;
  INTCONbits.GIE = 1;

  while (1) {
    /*if (del_vrem1) {
      del_vrem1 = 0;
      //del_vrem = 0;
      schet_vrem ();
    }// else del_vrem++;*/

    //while (sch_gotovo) {

    povtor:

    //flagi2.mod_zvuk = ~flagi2.mod_zvuk;
    //v_zvuka = flagi2.mod_zvuk & del_vrem1;

    if (del_vrem & 0xc0) {
      del_vrem &= 0x3f;
      //del_vrem = 0;
      //flagi.strob = 1;
      flagi.strob_plmn = 1;

      /*if (sch_gotovo && (del_vrem1 & 1)) {

        proverka:

        while (!(del_vrem & 0xc0)) {
          schzvk++;
          if ((schzvk & 0x7) == 7) flagi2.mod_zvuk = ~flagi2.mod_zvuk;
          v_zvuka = flagi2.mod_zvuk;//schzvk;// & del_vrem1;
        }

        goto proverka;

        v_zvuka = 0;
      }*/

      if (del_vrem1==3) {
        if (del_vrem2==59) schet_vrem ();
        if (flagi.vkl_otschet) {
          if (del_vrem2==59) schet_rele ();
          if (!rele.znach && !sch_gotovo) {
            flagi.gotovo = 1;
            flagi.nastr = 0;
            sch_gotovo = 7;
            //schzvk = 1;
          }
        }

        if (sch_vozv) {
          if (sch_vozv!=6) sch_vozv++; else {
            sch_vozv = 0;
            if (flagi.vkl_otschet) {
              flagi.nastr = 0;
              flagi.vyb_ch_m = 1;
            } else perekl_v_chasy();
          }
        }

        sch_ust++;
        if (del_vrem2==59) del_vrem2 = 0; else del_vrem2++;
        del_vrem1 = 0;
      } else del_vrem1++;

        if (sch_gotovo) {
//      while (!(del_vrem & 0xc0)) {
//        flagi2.mod_zvuk = ~flagi2.mod_zvuk;
//        v_zvuka = flagi2.mod_zvuk & del_vrem1;
//      }
          if (flagi.vkl_zvuk)
          v_zvuka = /*flagi.vkl_zvuk &*/ ~sch_gotovo;// & 1);
          //schzvk++;

          sch_gotovo--;
          if (!sch_gotovo) {
            perekl_v_chasy ();
//            flagi.nastr = 0;
//            flagi.vyb_ch_m = 0;
            //v_zvuka = 0;
          }
        }

    }// else del_vrem++;

    if (sch_gotovo) //{
  //    while (del_vrem & 0xc0) {
    //    flagi2.mod_zvuk = ~flagi2.mod_zvuk;
        //v_zvuka = flagi2.mod_zvuk & del_vrem1;
//      }
      goto povtor;
    //}
    //}

/*    vremsch++;

    if (vremsch==0) {
      vremsch = 200;

//      schet_vrem ();

      vyv_bukva = znaki[(vremja.znach >> ((3-sch_seg) << 2)) & 0xf];
      vyv_bukva = ~vyv_bukva;

      otp_bait(vyv_bukva, 0);
      otp_bait((vyv_bukva >> 8) | porjadok[sch_seg], 1);


      if (sch_seg==3) sch_seg = 0; else sch_seg++;
      //otp_bait(vremsch);

    }*/

/*    if (promez.znach) GP0 = 0;
    vrem = promez.znach;
    while (vrem) vrem--;
    if (impuls.znach) GP0 = 1;
    vrem = impuls.znach;
    while (vrem) vrem--;

    if (!ADCON0bits.GO_DONE) {
      impuls.baity.mladsh = ADRESL;
      impuls.baity.starsh = ADRESH;

      promez.znach = 0x3ff-impuls.znach;
      ADCON0bits.GO_DONE = 1;
    }
*/
//    if (promez) GP0 = 0;
    /*vrem = 15;//promez;
    //while (vrem) vrem--;
//    if (impuls) GP0 = 1;
    GP0 = 1;//GP3;
    vrem = 0x7;//impuls;
    while (vrem) vrem--;
    GP0 = 0;*/

    if (!ADCON0bits.GO_DONE) {
      //impuls = 0xf;//ADRESH;
//      promez = /*0xff-*/ADRESH;//impuls;
      //ind_knop.baity.minuty = ADRESH >> 3;

      /*INTCONbits.GIE = 0;

      //vremja.baity.minuty = ADRESH >> 3;
      vremja.baity.minuty = 0;

      del_vrem1 = ADRESH >> 3;
      while (del_vrem1) {
        schet_vrem ();
        del_vrem1--;
      }
      INTCONbits.GIE = 1;*/

      knopki = ADRESH >> 3;//5;
      //knopki = 7;

      //vremja.baity.minuty = ADRESH >> 5;
      //  schet_vrem ();
      ADCON0bits.GO_DONE = 1;
    }

    //if (flagi.strob) {
      //flagi.strob = 0;
      switch (knopki) {
        case knop_vyb: { if (flagi.strob_vyb) {
                    if (flagi.nastr) flagi.vyb_ch_m = ~flagi.vyb_ch_m;//flagi.vyb_seg++;
                    if (/*flagi.vyb_seg==3*/flagi.nastr && flagi.vyb_ch_m) flagi.nastr = 0; else flagi.nastr = 1;
                  }
                  flagi.strob_vyb = 0;

                  if (sch_ust==3) {
                    sch_ust = 0;
                    /*if (flagi.vr_rele) {
                      flagi.vr_rele = 0;
                      tek_ind = &vremja;
                      ust_m = &vremja.baity.minuty;
                      ust_ch = &vremja.baity.chas;
                    } else {
                      flagi.vr_rele = 1;
                      tek_ind = &rele;
                      ust_m = &rele.baity.minuty;
                      ust_ch = &rele.baity.chas;
                    }*/
                    flagi.vkl_zvuk = ~flagi.vkl_zvuk;
                  }

                  /*if (!flagi.vr_rele)*/ sch_vozv = 1;
                  break; }
        case knop_pls: { if (flagi.nastr && flagi.strob_plmn) {
                    sch_pov = usk_schet >> 2;
                    usk_schet++;
                    while (sch_pov) {
                      if (flagi.vyb_ch_m) {
                        if ((*ust_m)==0x59) *ust_m = 0; else schet_chisla (ust_m);
                      } else {
                        if ((*ust_ch)==0x23) *ust_ch = 0; else schet_chisla (ust_ch);
                      }
                      sch_pov--;
                    }
                  }
                  /*if (!flagi.vr_rele)*/ sch_vozv = 1;
                  flagi.strob_plmn = 0;
                  //if (!flagi.nastr) {
                    flagi.nastr = 1;
                    //flagi.vyb_ch_m = 0;
                  //}
                  break; }
        case knop_min: { if (flagi.nastr && flagi.strob_plmn) {
                    sch_pov = usk_schet >> 2;
                    usk_schet++;
                    while (sch_pov) {
                      if (flagi.vyb_ch_m) {
                        if (!(*ust_m)) *ust_m = 0x59; else obr_schet_chisla (ust_m);
                      } else {
                        if (!(*ust_ch)) *ust_ch = 0x23; else obr_schet_chisla (ust_ch);
                      }
                      sch_pov--;
                    }
                  }
                  /*if (!flagi.vr_rele)*/ sch_vozv = 1;
                  flagi.strob_plmn = 0;
                  //if (!flagi.nastr) {
                    flagi.nastr = 1;
                    //flagi.vyb_ch_m = 0;
                  //}
                  break; }
        case knop_vkl: { if (flagi.strob_vyb/* && !flagi.vkl_otschet*/) {
                    /*if (flagi.vr_rele) {
                      flagi.vr_rele = 0;
                      tek_ind = &vremja;
                      ust_m = &vremja.baity.minuty;
                      ust_ch = &vremja.baity.chas;
                    } else {
                      flagi.vr_rele = 1;
                      tek_ind = &rele;
                      ust_m = &rele.baity.minuty;
                      ust_ch = &rele.baity.chas;
                    }*/

                    if (flagi.vr_rele) {
                      flagi.vkl_otschet = 1;
                      //sch_vozv = 0;
                    } else {
                      flagi.nastr = 1;
                      flagi.vyb_ch_m = 1;
                      //sch_vozv = 1;
                    }

                    sch_vozv = 1;
                    flagi.vr_rele = 1;
                    tek_ind = &rele;
                    ust_m = &rele.baity.minuty;
                    ust_ch = &rele.baity.chas;
                  }
                  flagi.strob_vyb = 0;
                  break; }
        case knop_vyk: { if (flagi.strob_vyb) {
/*                    flagi.vr_rele = 0;
                    tek_ind = &vremja;
                    ust_m = &vremja.baity.minuty;
                    ust_ch = &vremja.baity.chas;

                    flagi.vkl_otschet = 0;*/
                    perekl_v_chasy();
                  }
                  flagi.strob_vyb = 0;
                  break; }
        case /*7*/31: { flagi.strob_vyb = 1;
                        sch_ust = 0;
                        usk_schet = 4;

/*                        if (sch_vozv) {
                          if (sch_vozv!=6) sch_vozv++; else {
                            sch_vozv = 0;
                            perekl_v_chasy();
                          }
                        }*/

                        break;
                      }
      }
    //}
  }

    //return (EXIT_SUCCESS);
}

